package com.company.mapsample.view.tsite;

import com.company.mapsample.entity.TSite;

import com.company.mapsample.view.main.MainView;

import com.vaadin.flow.router.Route;
import io.jmix.flowui.view.*;
import io.jmix.maps.utils.GeometryUtils;
import io.jmix.mapsflowui.component.GeoMap;
import io.jmix.mapsflowui.component.event.MapClickEvent;
import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.geom.Point;

@Route(value = "tSites/:id", layout = MainView.class)
@ViewController("TSite.detail")
@ViewDescriptor("t-site-detail-view.xml")
@EditedEntityContainer("tSiteDc")
public class TSiteDetailView extends StandardDetailView<TSite> {
	@ViewComponent
	private GeoMap map;
	@Subscribe
	protected void onInit(View.InitEvent event) {
		map.setProjection(()->"EPSG:21781");
		map.setZoom( 10D );
	}

	@Subscribe
	public void onReady(final ReadyEvent event) {
		map.setProjection(()->getEditedEntity().getSitProjSysNameCustom());
		map.setCenter( new Coordinate( getEditedEntity().getSitExtentXMaxCustom(), getEditedEntity().getSitExtentYMaxCustom()) );
	}

	protected GeometryFactory geometryFactory = GeometryUtils.getGeometryFactory();
	@Subscribe("map")
	public void onMapMapClick(final MapClickEvent event) {
		Point point = geometryFactory.createPoint(event.getCoordinate());
		TSite site = getEditedEntity();
		site.setSitWktWgs84(point);
	}

}